#version 150

#moj_import <fog.glsl>
#moj_import <shader_utils.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

in float vertexDistance;
in vec4 vertexColor;
in vec2 texCoord0;
in vec4 normal;
in vec4 lightmap;

out vec4 fragColor;

void main() {
    float alpha = texture(Sampler0, texCoord0).a * 255.0;
    vec4 color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator * lightmap;

    if(alpha == 254){
        color = texture(Sampler0, texCoord0);
    }

    if(alpha == 251){
        vec3 grayLightmap = toGrayscale(lightmap.rgb);
        vec3 blueLightmap = lightmap.rgb * vec3(0, 0.7, 1);
        color = texture(Sampler0, texCoord0) * vertexColor * ColorModulator * vec4(mix(lightmap.rgb, blueLightmap * 9, grayLightmap * 1.2), lightmap.a);
    }

    if(alpha == 252){
        discard;
    }

    fragColor = linear_fog(getFixedBlueWhiteColor(color, texture(Sampler0, texCoord0)), vertexDistance, FogStart, FogEnd, FogColor);
}
